from callback.Callback import Callback
from matrix_wrapper import *
import subprocess
from callback.callbacks import DiskUsageCallback


class DiskUsageCallback(Callback):
    BASE_DIR = os.environ["BASE_DIR"]
    ACTION_NAME = "du"

    async def run(self, args: dict):
        dir_size = {}
        directories = args.get(Callback.NO_PARAM)

        if not directories:
            dir_size.update({DiskUsageCallback.BASE_DIR: self.get_dir_size(DiskUsageCallback.BASE_DIR)})

        else:
            for directory in directories:
                try:
                    full_directory = "{}/{}".format(DiskUsageCallback.BASE_DIR, directory)
                    dir_size.update({directory: self.get_dir_size(full_directory)})
                except Exception as e:
                    await send_message("error encountered: {}".format(e))
                    return

        message = """<h2>Disk Usages</h2>
<table>
    <tr>
        <th>Directory</th>
        <th>Disk Usage</th>
    </tr>
"""
        for key, value in dir_size.items():
            message += "<tr><td>{}</td><td>{}</td></tr>".format(key, value)

        message += "</table>"

        await send_html(message)


    def get_dir_size(directory: str):
        return subprocess.check_output(['du','-sh', directory]).split()[0].decode('utf-8')